#include "BulletPhysics.h"

#include <iostream>
using namespace cgue::thewall;

	BulletPhysics::BulletPhysics(){
		stoneBool = false;

	/*for(int i = 0; i < 225; i++){
		tree[i] = _tree[i];
	}

	for(int i = 0; i < 5; i++){
		key[i] = _key[i];
	}
	*/
	//Build the broadphase
	broadphase = new btDbvtBroadphase();

	//Set up the collision configuration and dispatcher
	collisionConfiguration = new btDefaultCollisionConfiguration();
	dispatcher = new btCollisionDispatcher(collisionConfiguration);

	//The actual physics solver 
	solver = new btSequentialImpulseConstraintSolver;


	//The world
	dynamicsWorld = new btDiscreteDynamicsWorld(dispatcher, broadphase, solver, collisionConfiguration);
	//dynamicsWorld->setGravity(btVector3(0,-10.0f,0));
	dynamicsWorld->setGravity(btVector3(0,0,0));
	
	slanderRigidBody = NULL;
	

}

	//Hier werden die Rigid Bodys aller Bume initialisiert
void BulletPhysics::initTreeRigidBody(){
	treeCollisionShape = new btCylinderShape(btVector3(0.8,4,0.8));

	
	float startpos = -((sqrt(225) - 1)/2 * 5);
	float x = startpos;
	float z = startpos;
	float rotate = 0.0f;

		for(int i = 0; i < 225; i++){

			
			btDefaultMotionState* motionstate = new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1), 
				btVector3(x,
				ground->findHigh(x,z),
				z)));
		
			if(x == -startpos){
				z += 5.0f;
				x = startpos;
			}else{
				x += 5.0f;
			}
		
			btRigidBody::btRigidBodyConstructionInfo rigidBodyCI(
			0,	//mass, in kg. 0 -> static object, will never move
			motionstate,
			treeCollisionShape,	//collision Shape of body
			btVector3(0,0,0)	//local inertia
			);
		
			rigidBody[i] = new btRigidBody(rigidBodyCI);
			dynamicsWorld->addRigidBody(rigidBody[i]);
		}	


}
	
	//CharakterController hinzufgen
	void BulletPhysics::initCharacterRigidBody(){
		
		cameraShape= new btSphereShape(1.0f);
		//cameraShape->setMargin(0.1);
		btDefaultMotionState* cameraMotionState = new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1), btVector3(0,ground->findHigh(0,0)+1,0)));
		btScalar mass(70.0f);
		btVector3 cameraInertia(0,0,0);

		cameraShape->calculateLocalInertia(mass, cameraInertia);

		btRigidBody::btRigidBodyConstructionInfo cameraRigidBodyCI(mass, cameraMotionState, cameraShape, cameraInertia);
		cameraRigidBody = new btRigidBody(cameraRigidBodyCI);	
		cameraRigidBody->setUserPointer((void*)0);
		dynamicsWorld->addRigidBody(cameraRigidBody);
	
	}

	void BulletPhysics::initStoneRigidBody(){
		stoneInAir = true;
		stoneShape = new btSphereShape(1.0f);
		btDefaultMotionState* stoneMotionState = new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1), btVector3(
			cameraRigidBody->getWorldTransform().getOrigin().x(),
			ground->findHigh(cameraRigidBody->getWorldTransform().getOrigin().x(),cameraRigidBody->getWorldTransform().getOrigin().z())+1,
			cameraRigidBody->getWorldTransform().getOrigin().z()))
			);
		btScalar mass(10.0f);
		btVector3 stoneInertia(0,0,0);

		stoneShape->calculateLocalInertia(mass, stoneInertia);
		btRigidBody::btRigidBodyConstructionInfo cameraRigidBodyCI(mass, stoneMotionState, stoneShape, stoneInertia);
		stoneRigidBody = new btRigidBody(cameraRigidBodyCI);	
		stoneRigidBody->setUserPointer((void*)6);
		dynamicsWorld->addRigidBody(stoneRigidBody);
	
	}
	//Der Rabe fliegt von diesem Baum bis zur Mauer. Wenn er kollidiert, startet er wieder bei diesem Baum
	void BulletPhysics::initRavenRigidBody(){

		ravenShape = new btSphereShape(0.5f);
		btDefaultMotionState* ravenMotionState = new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1), btVector3(
			cameraRigidBody->getWorldTransform().getOrigin().x(),
			ground->findHigh(cameraRigidBody->getWorldTransform().getOrigin().x(),cameraRigidBody->getWorldTransform().getOrigin().z()+1)+4,
			cameraRigidBody->getWorldTransform().getOrigin().z()+1))
			);
		btScalar mass(1.0f);
		btVector3 ravenInertia(0,0,0);

		ravenShape->calculateLocalInertia(mass, ravenInertia);
		btRigidBody::btRigidBodyConstructionInfo ravenRigidBodyCI(mass, ravenMotionState, ravenShape, ravenInertia);
		ravenRigidBody = new btRigidBody(ravenRigidBodyCI);	
		ravenRigidBody->setUserPointer((void*)8);
		dynamicsWorld->addRigidBody(ravenRigidBody);
	
		
	}

	void BulletPhysics::initGroundRigidBody(Surrounding* surrounding){
	
		//GroundShape bekommen
		groundShape = surrounding->collisionShape;
	
		btDefaultMotionState* groundMotionState =
					new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1),btVector3(0, -5, 0)));
	
		btRigidBody::btRigidBodyConstructionInfo groundRigidBodyCI(0,groundMotionState, groundShape, btVector3(0,0,0));
		groundRigidBody = new btRigidBody(groundRigidBodyCI);
		groundRigidBody->setUserPointer((void*)7);
		dynamicsWorld->addRigidBody(groundRigidBody);
	
	}
	void BulletPhysics::initSlanderRigidBody(){
			
		slanderShape = new btCylinderShape(btVector3(1.0,4,1.0));

		int p = rand()%225;
		
		btDefaultMotionState* motionstate = new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1), 
			btVector3(rigidBody[p]->getWorldTransform().getOrigin().x()+2,
			ground->findHigh(rigidBody[p]->getWorldTransform().getOrigin().x()+2,rigidBody[p]->getWorldTransform().getOrigin().z()),
			rigidBody[p]->getWorldTransform().getOrigin().z())));
		
		
		btRigidBody::btRigidBodyConstructionInfo rigidBodyCI(
		0,	//mass, in kg. 0 -> static object, will never move
		motionstate,
		slanderShape,	//collision Shape of body
		btVector3(0,0,0)	//local inertia
		);
		
			slanderRigidBody = new btRigidBody(rigidBodyCI);
			slanderRigidBody->setUserPointer((void*)9);
			dynamicsWorld->addRigidBody(slanderRigidBody);
	
	}

/*	void BulletPhysics::initKeyRigidBody(){
		int pos[5] = {2, 35, 28, 110, 212};
/*	for(int i = 0; i < 5; i++){
		int p = rand()%225;
		for(int j = 0; j < i; j++){
			if(p == pos[j]){
				i--;
				continue;
			}
		}
		pos[i] = p;
	}
	
	//KeyRigidBody
	keyShape = new btBoxShape(btVector3(0.1,0.5,0.1));

	for(int i =0; i < 5; i++){
	btDefaultMotionState* keyMotionState = new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1),btVector3(
		rigidBody[pos[i]]->getWorldTransform().getOrigin().x()+1.5, 
		ground->findHigh(rigidBody[pos[i]]->getWorldTransform().getOrigin().x(), rigidBody[pos[i]]->getWorldTransform().getOrigin().z()), 
		rigidBody[pos[i]]->getWorldTransform().getOrigin().z())));
	btRigidBody::btRigidBodyConstructionInfo keyRigidBodyCI(0, keyMotionState, keyShape, btVector3(0,0,0));

	keyRigidBody[i] = new btRigidBody(keyRigidBodyCI);
	keyRigidBody[i]->setUserPointer((void*)(i+1));
	

	dynamicsWorld->addRigidBody(keyRigidBody[i]);
	}	
}
*/
	BulletPhysics::~BulletPhysics(){
		//Delete TreeCollision
		for(int i = 0; i < 225; i++){
			dynamicsWorld->removeRigidBody(rigidBody[i]);
			delete rigidBody[i]->getMotionState();
			delete rigidBody[i];
		}

		//Delete KEy
		/*for(int i = 0; i < 5;i++){
			if(keyRigidBody[i] != NULL){
			dynamicsWorld->removeRigidBody(keyRigidBody[i]);
			delete keyRigidBody[i]->getMotionState();
			delete keyRigidBody[i];
			}
		}*/
		//Delete Person
		dynamicsWorld->removeRigidBody(cameraRigidBody);
		delete cameraRigidBody->getMotionState();
		delete cameraRigidBody;
		
		//Delete Stone
		if(stoneBool){
		dynamicsWorld->removeRigidBody(stoneRigidBody);
		delete stoneRigidBody->getMotionState();
		delete stoneRigidBody;
		}
		//Delete Ground
		dynamicsWorld->removeRigidBody(groundRigidBody);
		delete groundRigidBody->getMotionState();
		delete groundRigidBody;

		//Delete Collision Shapes
		delete treeCollisionShape;
		delete cameraShape;
		delete groundShape;
		delete stoneShape;
		
		//DElete raven
		dynamicsWorld->removeRigidBody(ravenRigidBody);
		delete ravenRigidBody->getMotionState();
		delete ravenRigidBody;
		
		if(slanderRigidBody != NULL){
		dynamicsWorld->removeRigidBody(slanderRigidBody);
		delete slanderRigidBody->getMotionState();
		delete slanderRigidBody;
		}

		delete broadphase;
		delete collisionConfiguration;
		delete dispatcher;
		delete solver;
		delete dynamicsWorld;
	
	}
	/*
	0: Character
	1-5: Schlssel
	6:Stone
	7:ground
	8: Rabe kollidiert mit Mauer
	9: Stein Kollidiert mit Slander
	*/
	void BulletPhysics::checkCollision(std::vector<int>* collision){
		
		int numManifolds = dynamicsWorld->getDispatcher()->getNumManifolds();
		
		for(int i = 0; i < numManifolds; i++){
			btPersistentManifold* contactManifold = dynamicsWorld->getDispatcher()->getManifoldByIndexInternal(i);
			btCollisionObject* obA = (btCollisionObject*)(contactManifold->getBody0());
			btCollisionObject* obB = (btCollisionObject*)(contactManifold->getBody1());
	
			int numContacts = contactManifold->getNumContacts();
				for (int j=0;j<numContacts;j++){

					btManifoldPoint& pt = contactManifold->getContactPoint(j);
					if(pt.getDistance()<0.0f){

			int thisObject = (int)(obA->getUserPointer());
			int thatObject = (int)(obB->getUserPointer());
			
			/*if(thisObject == 0){
			/*	if(thatObject >= 1 && thatObject <=5){
				std::cout<<"ich habe einen Schlssel gefunden! "<< thatObject << std::endl;
				//Nun muss der gefundene Schlssel gelscht werden

				dynamicsWorld->removeRigidBody(keyRigidBody[thatObject-1]);
				delete keyRigidBody[thatObject-1]->getMotionState();
				delete keyRigidBody[thatObject-1];
				keyRigidBody[thatObject-1] = NULL;
		
				if(checkCollisionVector(collision, thatObject)){
				collision->push_back(thatObject);
				}
				}
				 if(!stoneInAir && thatObject == 6){//Ich kolliddiere mit Stein 6
				std::cout<<"Ich habe den Stein erreicht"<<std::endl;
					dynamicsWorld->removeRigidBody(stoneRigidBody);
					delete stoneRigidBody->getMotionState();
					delete stoneRigidBody;
					stoneRigidBody = NULL;
					if(checkCollisionVector(collision, thatObject)){
					collision->push_back(thatObject);
					}
				}
			}*/
			if(stoneInAir && thisObject == 6){
				if(thatObject == 9){ //Kollision von Stein mit SlanderMan
					std::cout<<"Ich kollidiere mit Slanderman"<<std::endl;
					stoneInAir = false;			
					//Simuliere kollision von Stein mit Boden
					btDefaultMotionState* stoneMotionState = new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1), btVector3(
					stoneRigidBody->getWorldTransform().getOrigin().x(),
					ground->findHigh(stoneRigidBody->getWorldTransform().getOrigin().x(),stoneRigidBody->getWorldTransform().getOrigin().z())+1,
					stoneRigidBody->getWorldTransform().getOrigin().z())));
		
					stoneRigidBody->setMotionState(stoneMotionState);
					stoneRigidBody->setLinearVelocity(btVector3(0,0,0));


					dynamicsWorld->removeRigidBody(slanderRigidBody);
					delete slanderRigidBody->getMotionState();
					delete slanderRigidBody;
					slanderRigidBody = NULL;

					dynamicsWorld->removeRigidBody(stoneRigidBody);
					delete stoneRigidBody->getMotionState();
					delete stoneRigidBody;
					stoneRigidBody = NULL;
					if(checkCollisionVector(collision, thatObject)){
					collision->push_back(thatObject);
					}
				}
				else if(thatObject == 7){ //Kollision von Stein mit Boden 7
					//Stein kollidiert mit Boden
					std::cout<<"Stein kollidiert mit Boden!"<<std::endl;
					stoneInAir = false;			
					btDefaultMotionState* stoneMotionState = new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1), btVector3(
					stoneRigidBody->getWorldTransform().getOrigin().x(),
					ground->findHigh(stoneRigidBody->getWorldTransform().getOrigin().x(),stoneRigidBody->getWorldTransform().getOrigin().z())+1,
					stoneRigidBody->getWorldTransform().getOrigin().z())));
		
					stoneRigidBody->setMotionState(stoneMotionState);
					stoneRigidBody->setLinearVelocity(btVector3(0,0,0));

					if(checkCollisionVector(collision, thatObject)){
					collision->push_back(thatObject);
					}
				}
			}
		/*	else if(thisObject == 8){
				if(thatObject == 7){//Rabe kollidiert mit Mauer
					btDefaultMotionState* ravenMotionState = new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1), btVector3(
						rigidBody[0]->getWorldTransform().getOrigin().x()+2,
						ground->findHigh(rigidBody[0]->getWorldTransform().getOrigin().x()+2,rigidBody[0]->getWorldTransform().getOrigin().z())+4,
						rigidBody[0]->getWorldTransform().getOrigin().z()))
						);
		
					ravenRigidBody->setMotionState(ravenMotionState);
					

				}
			
			
			}*/
			}
					
			
		}


		}

	}
	/*
	Wenn in der kollision, der stein mit dem boden kollidiert ist, kann er nicht gleichzeitig mit der person kollidieren
	Wenn der Stein mit dem Slander kollidiert, kann er vorher nicht mit dem Boden oder der Person kollidiert sein
	6: ich mit Stein
	7: Stein mit Boden
	9: stein mit Slander
	*/
	bool BulletPhysics::checkCollisionVector(std::vector<int>* collision, int c){//berprfe, ob so eine kollision schon mal vorkommt.
		for(int i = 0; i < collision->size(); i++){
			if(collision->at(i) == c){
				return false;
			}
			else if(c ==6 && collision->at(i) == 7){
				return false;
			}
			else if(c== 6 && collision->at(i) == 9){
				return false;
			}
			else if(c == 7 && collision->at(i) == 9){
				return false;
			}
			else if(c==7 && collision->at(i) == 6){
				return false;
			}
			else if(c == 9 && collision->at(i) == 6){
				return false;
			}
			else if(c == 9 && collision->at(i) == 7){
				return false;
			}
		}
		return true;
	}

	btDiscreteDynamicsWorld* BulletPhysics::getDynamicWorld(){
		return dynamicsWorld;
	}

	btRigidBody* BulletPhysics::getGroundRigidBody(){
		return groundRigidBody;
	}

	btRigidBody* BulletPhysics::getCameraRigidBody(){
		return cameraRigidBody;
	}

	btRigidBody* BulletPhysics::getStoneRigidBody(){
		return stoneRigidBody;
	}

	void BulletPhysics::setStoneBool(bool boolean){
		stoneBool = boolean;
	}

	btRigidBody* BulletPhysics::getTreeRigidBody(int index){
	return rigidBody[index];
	}

	void BulletPhysics::setGround(Ground* _ground){
		ground = _ground;
	}

	btRigidBody* BulletPhysics::getKeyRigidBody(int index){
	return keyRigidBody[index];
	}

	btRigidBody* BulletPhysics::getRavenRigidBody(){
		return ravenRigidBody;
	}

	btRigidBody* BulletPhysics::getSlanderRigidBody(){
		return slanderRigidBody;
	}

	void BulletPhysics::collisionWithKey(int index){
	std::cout<<"ich habe einen Schlssel gefunden! "<< std::endl;
				
		//	dynamicsWorld->removeRigidBody(keyRigidBody[index]);
		//	delete keyRigidBody[index]->getMotionState();
		//	delete keyRigidBody[index];
		//		keyRigidBody[index] = NULL;
		
	}

	void BulletPhysics::collisionWithStone(){
		std::cout<<"Ich habe den Stein erreicht"<<std::endl;
		dynamicsWorld->removeRigidBody(stoneRigidBody);
		delete stoneRigidBody->getMotionState();
		delete stoneRigidBody;
		stoneRigidBody = NULL;
				
	}