
#include "bullet-2.81-rev2613\src\btBulletDynamicsCommon.h"
#include "Scene\Tree.h"
#include "Scene\Ground.h"
#include "Scene\Key.h"
#include "Scene\Surrounding.h"

using namespace cgue::thewall::scene;

namespace cgue{
	namespace thewall{
		class BulletPhysics
		{
		public:
			BulletPhysics();
			~BulletPhysics(void);

			btDiscreteDynamicsWorld* getDynamicWorld();
			btRigidBody* getCameraRigidBody();
			btRigidBody* getStoneRigidBody();
			btRigidBody* getGroundRigidBody();
			btRigidBody* getTreeRigidBody(int index);
			btRigidBody* getKeyRigidBody(int index);
			btRigidBody* getRavenRigidBody();
			btRigidBody* getSlanderRigidBody();

			void collisionWithStone();
			void collisionWithKey(int index);

			void checkCollision(std::vector<int>* collision);
			
			void setStoneBool(bool boolean);
			void setGround(Ground* _ground);
			void setStoneOnGround();

			void initStoneRigidBody();
			void initTreeRigidBody();
			void initCharacterRigidBody();
			void initGroundRigidBody(Surrounding* surroud);
			void initKeyRigidBody();
			void initRavenRigidBody();
			void initSlanderRigidBody();

		private:
			btBroadphaseInterface* broadphase;
			btDefaultCollisionConfiguration* collisionConfiguration;
			btCollisionDispatcher* dispatcher;
			btSequentialImpulseConstraintSolver* solver;
			btDiscreteDynamicsWorld* dynamicsWorld;

			bool checkCollisionVector(std::vector<int>* collision, int c);
			bool stoneBool;
			bool stoneInAir;
			//SceneObjects
			//Tree* tree[225];		//Muss gendert werden, falls man mehr Bume hinzufgen mchte
			Key* key[5];
			Ground* ground;

		
			//Collision Shapes
			btCollisionShape* cameraShape;	
			btCollisionShape* treeCollisionShape;
			btCollisionShape* groundShape;
			btCollisionShape* keyShape;
			btCollisionShape* stoneShape;
			btCollisionShape* ravenShape;
			btCollisionShape* slanderShape;

			//RigidBodys
			btRigidBody* ravenRigidBody;
			btRigidBody* rigidBody[225];	//muss auch gendert werden, wenn man mehrere Bume hinzufgt
			btRigidBody* groundRigidBody; 
			btRigidBody* cameraRigidBody;
			btRigidBody* keyRigidBody[5];
			btRigidBody* stoneRigidBody;
			btRigidBody* slanderRigidBody;

		
			
		};
	}
}

