#pragma once
#include <GL/glew.h>
#include "Shader.h"
#include "Texture.h"
namespace cgue{
	namespace thewall{
		class Fbo
		{
		public:
			Fbo(int _WIDTH, int _HEIGHT);
			~Fbo(void);
			
			void drawGaussTex(Shader* gaussHorizontalShader, Shader* gaussFinalShader);
			void renderOnScreen(Shader* textureShader);
			GLuint getFbo();
			void initRenderedSceneTexture();
			void initAlphaTexture();
			void endGame(Shader* endGameShader, Texture* tex);
		private:
			int WIDTH, HEIGHT;
			//FrameBufferObject zum Rendern der Scene auf eine Textur
			GLuint fboId;//This will store our fbo-name
			GLuint textureId;	//Fr die Gerenderte Textur
			GLuint alphaTexturId;	//Fr den Alphakanal

			//FragmentBufferObject zum Gauss anwenden
			GLuint gaussHorizontalTexturId;
			GLuint gaussFinalTexturId;
			GLuint fboGaussId;

			//Zum rendern der resultierenden TExtur am Bildschirm
			GLuint quad_vertexbuffer;
			GLfloat g_quad_vertex_buffer_data[18]; 

		
					
		};
	}
}
