#include "MausKeyboard.h"
#include <iostream>

using namespace glm;
using namespace cgue::thewall;
using namespace cgue::thewall::scene;

MausKeyboard::MausKeyboard(Ground* _ground)
{

	ground = _ground;
	stoneRigidBody == NULL;

	// Initial horizontal angle : toward -Z
	horizontalAngle = 3.14f;
	// Initial vertical angle : none
	verticalAngle = 0.0f;
	// Initial Field of View
	initialFoV = 45.0f;
	
	height = 0;

	mouseSpeed = 0.005f;
	jump = false;
	jumpDown=false;
	stoneDown = false;
	deltaJump = 0.0f;
	deltaStoneHeight = 0.0f;

	w_key = false;
	s_key = false;
	a_key = false;
	d_key = false;
	e_key = false;
	space_key = false;
	shift_key = false;
	xpos = 0.0;
	ypos = 0.0;
}


MausKeyboard::~MausKeyboard(void)
{
}

void MausKeyboard::computeMatricesFromInputs(float deltaTime, const int WIDTH, const int HEIGHT, bool* stone, btRigidBody* cameraRigidBody){
	
	if(!jump){
		height = 0;
	}

	float speed = 2.0f;

	//Geschwindigkeit muss wieder auf 0 gesetzt werden, damit wenn ich die Tasten auslasse, die Kamera stehen bleibt
	cameraRigidBody->setLinearVelocity(btVector3(0,0,0));
	if(*stone){
	stoneRigidBody->setLinearVelocity(btVector3(0,0,0));
	}

	// Compute new orientation
	horizontalAngle += mouseSpeed * float(WIDTH/2 - xpos);
	verticalAngle   += mouseSpeed * float(HEIGHT/2 - ypos);
	if(verticalAngle < -0.9f)
		verticalAngle = -0.9f;
	if(verticalAngle > 1.5f)
		verticalAngle = 1.5f;
	xpos = WIDTH/2;
	ypos = HEIGHT/2;

	// Direction : Spherical coordinates to Cartesian coordinates conversion
	direction = vec3(
		cos(verticalAngle) * sin(horizontalAngle), 
		sin(verticalAngle),
		cos(verticalAngle) * cos(horizontalAngle)
	);
	
	// Right vector
	vec3 right = vec3(
		sin(horizontalAngle - 3.14f/2.0f), 
		0,
		cos(horizontalAngle - 3.14f/2.0f)
	);
	
	momdirection = btVector3(direction.x,direction.y, direction.z);
	// Up vector
	up = cross(right, direction);
	up = vec3(0,1,0);

	// Speed Up
	
	if(shift_key&&(
		w_key ||
		s_key ||
		d_key ||
		a_key)){
				speed=speed+2.0f;
			//Eventuell schwanken der Kamera einbauen
	
	}
	btVector3 velocityDirection = btVector3(0,0,0);
	
	// Move forward
	if (w_key){
		cameraRigidBody->activate();
		//cameraRigidBody->setLinearVelocity(btVector3(direction.x(), 0 , direction.z()));
		velocityDirection += btVector3(direction.x, direction.y, direction.z);

		height = ground->findHigh(cameraRigidBody->getWorldTransform().getOrigin().x() + speed*velocityDirection.x(),
									 cameraRigidBody->getWorldTransform().getOrigin().z() + speed*velocityDirection.z());
		height = height - cameraRigidBody->getWorldTransform().getOrigin().y();
	
	}
	// Move backward
	if (s_key){
		cameraRigidBody->activate();
		//cameraRigidBody->setLinearVelocity(btVector3(-direction.x(), 0 , -direction.z()));
		velocityDirection -= btVector3(direction.x, direction.y, direction.z);

		height = ground->findHigh(cameraRigidBody->getWorldTransform().getOrigin().x() + speed*velocityDirection.x(),
									 cameraRigidBody->getWorldTransform().getOrigin().z() + speed*velocityDirection.z());
		height = height - cameraRigidBody->getWorldTransform().getOrigin().y();
	
	}
	// Strafe right
	if (d_key){
		cameraRigidBody->activate();
		//cameraRigidBody->setLinearVelocity(btVector3(right.x(),0,right.z()));
		velocityDirection += btVector3(right.x, right.y, right.z);
		height = ground->findHigh(cameraRigidBody->getWorldTransform().getOrigin().x() + speed*velocityDirection.x(),
									 cameraRigidBody->getWorldTransform().getOrigin().z() + speed*velocityDirection.z());
		height = height - cameraRigidBody->getWorldTransform().getOrigin().y();
	
	}
	// Strafe left
	if (a_key){
		cameraRigidBody->activate();
		//cameraRigidBody->setLinearVelocity(btVector3(-right.x(),0,-right.z()));
		velocityDirection -= btVector3(right.x, right.y, right.z);
		height = ground->findHigh(cameraRigidBody->getWorldTransform().getOrigin().x() + speed*velocityDirection.x(),
									 cameraRigidBody->getWorldTransform().getOrigin().z() + speed*velocityDirection.z());
		height = height - cameraRigidBody->getWorldTransform().getOrigin().y();
	}

	if (space_key){
		cameraRigidBody->activate();
		if(!jump){
			jump = true;
		}
	}

	if(jump){
		if(deltaJump >1.5){
		jumpDown = true;
		}
		if(!jumpDown) {
			if(deltaJump <= 0.2){
			deltaJump+=0.4;
			}
			else if(deltaJump <0.4 && deltaJump >0.2){
			deltaJump+=0.3;
			}
			else if(deltaJump <= 0.7 && deltaJump >= 0.4){
			deltaJump+=0.2;
			}
			else{
			deltaJump += 0.1;
			}
	
		cameraRigidBody->setLinearVelocity(btVector3(2*velocityDirection.x(), deltaJump, 2*velocityDirection.z()));
		}else{	//Man fllt wieder
			if(deltaJump < 0){
				jump = false;
				deltaJump = 0;
				jumpDown = false;
				height = 0;
			}
			else{
				if(deltaJump <= 0.2){
				deltaJump-=0.4;
				}
				else if(deltaJump <0.4 && deltaJump >0.2){
				deltaJump-=0.3;
				}
				else if(deltaJump <= 0.7 && deltaJump >= 0.4){
				deltaJump-=0.2;
				}
				else{
					deltaJump -= 0.1;
				}
				cameraRigidBody->setLinearVelocity(btVector3(2*velocityDirection.x(), -deltaJump, 2*velocityDirection.z()));
			}
		}
	}
	else{
		cameraRigidBody->setLinearVelocity(btVector3(speed*velocityDirection.x(), height, speed*velocityDirection.z()));
	}

	if(*stone){
		stoneRigidBody->activate();

		if(deltaStoneHeight >3){
		stoneDown= true;
		}
		if(!stoneDown) {
		
			deltaStoneHeight += 0.5;
		
	
		stoneRigidBody->setLinearVelocity(btVector3(4*stoneDirection.x(), 0.5, 4*stoneDirection.z()));
		}else{	//Stein fllt wieder

			deltaStoneHeight-=1;		
		if(deltaStoneHeight < 2){
			stoneRigidBody->setLinearVelocity(btVector3(4*stoneDirection.x(), -1.5, 4*stoneDirection.z()));
		}
		if(deltaStoneHeight < 1){
			stoneRigidBody->setLinearVelocity(btVector3(4*stoneDirection.x(), -2, 4*stoneDirection.z()));
		}
		else{
			stoneRigidBody->setLinearVelocity(btVector3(4*stoneDirection.x(), -1, 4*stoneDirection.z()));
		}
			//stoneRigidBody->setLinearVelocity(btVector3(4*stoneDirection.x(), -1, 4*stoneDirection.z()));
		

		}
	}
	
	if (e_key){
		if(!*stone && stoneRigidBody == NULL){
		*stone = true;
		stoneDirection = momdirection;
		}
	}



	float FoV = initialFoV;// - 5 * glfwGetMouseWheel(); // Now GLFW 3 requires setting up a callback for this. It's a bit too complicated for this beginner's tutorial, so it's disabled instead.

	// Projection matrix : 45 Field of View, 4:3 ratio, display range : 0.1 unit <-> 100 units
	ProjectionMatrix = perspective(FoV, 4.0f / 3.0f, 0.1f, 100.0f);
	// Camera matrix
	position = glm::vec3(
		cameraRigidBody->getWorldTransform().getOrigin().x(),
		cameraRigidBody->getWorldTransform().getOrigin().y(), 
		cameraRigidBody->getWorldTransform().getOrigin().z());
	
	ViewMatrix = lookAt(
								position,           // Camera is here
								position+direction, // and looks here : at the same position, plus "direction"
								up                  // Head is up (set to 0,-1,0 to look upside-down)
						   );
	 
	w_key = false;
	s_key = false;
	a_key = false;
	d_key = false;
	e_key = false;
	space_key = false;
	shift_key = false;
	
}
void MausKeyboard::xpos_mouse(double x_pos){xpos = x_pos;}
void MausKeyboard::ypos_mouse(double y_pos){ypos = y_pos;}
void MausKeyboard::w_key_pressed(){ w_key = true;}
void MausKeyboard::s_key_pressed(){ s_key = true;}
void MausKeyboard::a_key_pressed(){ a_key = true;}
void MausKeyboard::d_key_pressed(){ d_key = true;}
void MausKeyboard::e_key_pressed(){ e_key = true;}
void MausKeyboard::space_key_pressed(){ space_key = true;}
void MausKeyboard::shift_key_pressed(){ shift_key = true;}

mat4 MausKeyboard::getViewMatrix(){
	return ViewMatrix;
}

mat4 MausKeyboard::getProjectionMatrix(){
	return ProjectionMatrix;
}

glm::vec3 MausKeyboard::getPosition(){
	return position;
}

btVector3 MausKeyboard::getDirection(){
	return momdirection;
}

glm::vec3 MausKeyboard::getUp(){
	return up;
}
void MausKeyboard::setHeight(float h){
	position[1] = h;
}

void MausKeyboard::setStoneRigidBody(btRigidBody* _stone){
	stoneRigidBody=_stone;
}

void MausKeyboard::setStoneFalse(){
deltaStoneHeight = 0.0f;
stoneDown=false;
stoneDirection = (btVector3(0,0,0));
btDefaultMotionState* stoneMotionState = new btDefaultMotionState(btTransform(btQuaternion(0,0,0,1), btVector3(
	stoneRigidBody->getWorldTransform().getOrigin().x(),
	ground->findHigh(stoneRigidBody->getWorldTransform().getOrigin().x(),stoneRigidBody->getWorldTransform().getOrigin().z())+1,
	stoneRigidBody->getWorldTransform().getOrigin().z())));
		
stoneRigidBody->setMotionState(stoneMotionState);
stoneRigidBody->setLinearFactor(btVector3(0,0,0));
stoneRigidBody->activate();
}
