#pragma once

#define GLM_FORCE_RADIANS
#include <glm\glm.hpp>
#include <glm/gtc/type_ptr.hpp>
// glm::translate, glm::rotate, glm::scale
#include <glm/gtc/matrix_transform.hpp>
#include "Scene\Ground.h"
#include "bullet-2.81-rev2613\src\btBulletDynamicsCommon.h"

#include <GLFW\glfw3.h>

using namespace cgue::thewall::scene;

namespace cgue{
	namespace thewall{
		class MausKeyboard
		{
		public:
			MausKeyboard(Ground* _ground);
			~MausKeyboard(void);

			void computeMatricesFromInputs(float deltaTime, const int WIDTH, const int HEIGHT, bool* stone, btRigidBody* cameraRigidBody);
			glm::mat4 getViewMatrix();
			glm::mat4 getProjectionMatrix();
			glm::vec3 getPosition();
			btVector3 getDirection();
			glm::vec3 getUp();
			void setHeight(float h);
			void w_key_pressed();
			void s_key_pressed();
			void a_key_pressed();
			void d_key_pressed();
			void e_key_pressed();
			void space_key_pressed();
			void shift_key_pressed();
			void xpos_mouse(double x_pos);
			void ypos_mouse(double y_pos);
			glm::vec3 direction;

			void setStoneRigidBody(btRigidBody* _stone);
			void setStoneFalse();

		private:
			Ground* ground;
			btRigidBody* stoneRigidBody;
			glm::mat4 ViewMatrix;
			glm::mat4 ProjectionMatrix;

			// Initial horizontal angle : toward -Z
			float horizontalAngle;
			// Initial vertical angle : none
			float verticalAngle;
			// Initial Field of View
			float initialFoV;

			float mouseSpeed;
			//Stone
			float deltaStoneHeight;
			bool stoneDown;
			btVector3 stoneDirection;

			//Jump
			float deltaJump;
			bool jump;
			bool jumpDown;

			double height;
			//Position der Kamera
			glm::vec3 position;

			bool w_key;
			bool s_key;
			bool a_key;
			bool d_key;
			bool e_key;
			bool space_key;
			bool shift_key;

			double xpos;
			double ypos;

			btVector3 momdirection;
			glm::vec3 up;
		};
	}
}

