#include "Music.h"
#include "Info.h"

using namespace cgue::thewall;

Music::Music(){
	//init FMOD
	FMOD::System_Create(&system);
	system->init(32, FMOD_INIT_NORMAL, 0);

	//load sounds
	system->createSound("TheWall/music/forest2.wav", FMOD_HARDWARE, 0, &backgroundSound);
	backgroundSound->setMode(FMOD_LOOP_NORMAL);    

	system->createSound("TheWall/music/gameOverSound.mp3", FMOD_HARDWARE, 0, &gameOverSound);
	gameOverSound->setMode(FMOD_LOOP_OFF);    

	system->createSound("TheWall/music/plop.wav", FMOD_HARDWARE, 0, &plopSound);
	plopSound->setMode(FMOD_LOOP_OFF);    
	
	system->createSound("TheWall/music/key.mp3", FMOD_HARDWARE, 0, &keySound);
	keySound->setMode(FMOD_LOOP_OFF);    

	system->createSound("TheWall/music/killYou.mp3", FMOD_HARDWARE, 0, &slanderSound);
	slanderSound->setMode(FMOD_LOOP_OFF);    

	system->playSound(FMOD_CHANNEL_FREE, backgroundSound, false,&channel);


}

Music::~Music(){

	backgroundSound->release();
	gameOverSound->release();
	system->close();
	system->release();

}

FMOD::System* Music::getSystem(){
	return system;
}

void Music::stopBackgroundMusic(){
	channel->stop();
}

void Music::playGameOverSound(){
	system->playSound(FMOD_CHANNEL_FREE, gameOverSound, false,&channel2);
}

void Music::playPlopSound(){
	system->playSound(FMOD_CHANNEL_FREE, plopSound, false,&channel);

}

void Music::playKeySound(){
	system->playSound(FMOD_CHANNEL_FREE, keySound, false,&channel);
}
void Music::playSlanderSound(){
	system->playSound(FMOD_CHANNEL_FREE, slanderSound, false,&channel);
}