#pragma once
#define GLM_FORCE_RADIANS

#include <GL/glew.h>
#include "SceneObject.h"
#include "../Shader.h"


#define CUBE_VERTEX_COUNT 24 //Ecken + Normalen
#define CUBE_INDEX_COUNT 36

namespace cgue{
	namespace thewall{
		namespace scene{
			class Cube :
				public SceneObject
			{
			public:
				Cube(glm::mat4& matrix, Shader* _shader);
				virtual ~Cube(void);

				virtual void update(float deltaT);
				virtual void draw();
				virtual void drawDepth();

			private:
				GLuint vao;
				GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer;
				Shader* shader;

				virtual void setSurfaceParameters();

				std::vector< glm::vec3 > vertices;
				std::vector< glm::vec2 > uvs;
				std::vector< glm::vec3 > normals;
				std::vector< unsigned short > indices;
			};
		}
	}
}