#pragma once

#include <GL/glew.h>
#include <glm\glm.hpp>
#include "SceneObject.h"
#include "Wall.h"
#include "../Shader.h"
#include <vector>

namespace cgue{
	namespace thewall{
		namespace scene{
			class Ground :
				public SceneObject
			{
			public:
				Ground(glm::mat4& matrix, Shader* _shader);
				virtual ~Ground(void);

				virtual void update(float deltaT);
				virtual void draw();
				virtual void drawDepth();
				void setModelMatrix(btRigidBody* GroundRigidBody);
				
				virtual void generateCollisionShape();
				
				btBvhTriangleMeshShape* collisionShape;
				float findHigh(float x, float z);
				
				Texture* text;
				Texture* textNorm;
				
				Wall* wall;
				GLuint vao;
				GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer, tangentBuffer, bitangentBuffer;
				Shader* shader;

				virtual void setSurfaceParameters();

				std::vector< glm::vec3 > vertices;
				std::vector< glm::vec2 > uvs;
				std::vector< glm::vec3 > normals;

				std::vector<glm::vec3> tangents;
				std::vector<glm::vec3> bitangents;

				std::vector<unsigned short> indices;
			};
		}
	}
}
