#pragma once

#include <GL/glew.h>
#include <glm\glm.hpp>
#include "SceneObject.h"
#include "../Shader.h"
#include <vector>

namespace cgue{
	namespace thewall{
		namespace scene{
			class Key :
				public SceneObject
			{
				public:
				Key(glm::mat4& matrix, Shader* _shader);
				virtual ~Key(void);

				virtual void update(float deltaT);
				virtual void draw();
				virtual void drawDepth();
				void setModelMatrix(btRigidBody* keyRigidBody);
				
				
				static GLuint vao;
				static GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer;
				Shader* shader;

				virtual void setSurfaceParameters();

				static std::vector< glm::vec3 > vertices;
				static std::vector< glm::vec2 > uvs;
				static std::vector< glm::vec3 > normals;
				static std::vector< unsigned short > indices;
			};
		}
	}
}