#pragma once

#include <GL/glew.h>
#include <glm\glm.hpp>
#include "SceneObject.h"
#include "../Shader.h"
#include <vector>
#include "Ground.h"
#include "Wing.h"
#include <glm/gtc/type_ptr.hpp>
#include "../Texture.h"

namespace cgue{
	namespace thewall{
		namespace scene{
			class Raven :
				public SceneObject
			{
			public:
				Raven(glm::mat4& matrix, Shader* _shader, int _x, int _z);
				virtual ~Raven(void);

				virtual void update(float deltaT);
				virtual void draw();
				virtual void drawDepth();

				void setFly(bool b);
				void setDirection(glm::vec3 dir);
				void setModelMatrix(glm::mat4 mm);
				void setUp(glm::vec3 u);
				bool getFly();
				void setModelMatrix(btRigidBody* ravenRigidBody);
				GLuint vao;
				GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer;
				Shader* shader;
				Wing* wings[2];
				Texture* texture;
				int x, z;
				virtual void setSurfaceParameters();
				std::vector< glm::vec3 > vertices;
				std::vector< glm::vec2 > uvs;
				std::vector< glm::vec3 > normals;
				std::vector< unsigned short > indices;
				float phi;
				bool fly;
				glm::vec3 direction;
				glm::vec3 up;
			};
		}
	}
}
