#pragma once
#define SCENE_OBJECT

#include <glm/glm.hpp>
#include <vector>
#include "bullet-2.81-rev2613\src\btBulletDynamicsCommon.h"
#include <GL/glew.h>

namespace cgue{
	namespace thewall{
		namespace scene{
			class SceneObject
			{
			public:
				SceneObject(glm::mat4& _modelMatrix);
				virtual ~SceneObject(void);
				virtual void update(float deltaT) = 0;
				virtual void draw() = 0;
				virtual bool loadOBJ(std::string path,
					std::vector < glm::vec3 > & out_vertices,
					std::vector < glm::vec2 > & out_uvs,
					std::vector < glm::vec3 > & out_normals);
				virtual void computeTangentBasis(std::vector<glm::vec3> & vertices,	std::vector<glm::vec2> & uvs,std::vector<glm::vec3> & normals,
					std::vector<glm::vec3> & tangents,std::vector<glm::vec3> & bitangents);
				glm::mat4 modelMatrix;

				void indexVBO_TBN(
					std::vector<glm::vec3> & in_vertices,
					std::vector<glm::vec2> & in_uvs,
					std::vector<glm::vec3> & in_normals,
					std::vector<glm::vec3> & in_tangents,
					std::vector<glm::vec3> & in_bitangents,

					std::vector<unsigned short> & out_indices,
					std::vector<glm::vec3> & out_vertices,
					std::vector<glm::vec2> & out_uvs,
					std::vector<glm::vec3> & out_normals,
					std::vector<glm::vec3> & out_tangents,
					std::vector<glm::vec3> & out_bitangents
				);
				bool getSimilarVertexIndex( 
					glm::vec3 & in_vertex, 
					glm::vec2 & in_uv, 
					glm::vec3 & in_normal, 
					std::vector<glm::vec3> & out_vertices,
					std::vector<glm::vec2> & out_uvs,
					std::vector<glm::vec3> & out_normals,
					unsigned short & result
				);
				bool is_near(float v1, float v2);

				virtual void indexVBO(
					std::vector<glm::vec3> & in_vertices,
					std::vector<glm::vec2> & in_uvs,
					std::vector<glm::vec3> & in_normals,

					std::vector<unsigned short> & out_indices,
					std::vector<glm::vec3> & out_vertices,
					std::vector<glm::vec2> & out_uvs,
					std::vector<glm::vec3> & out_normals
				);

				virtual void vaoDepth(GLuint vertexbuffer, GLuint indexBuffer, std::vector<unsigned short> indices);

			};
		}
	}
}