#pragma once

#include <GL/glew.h>
#include <glm\glm.hpp>
#include "SceneObject.h"
#include "../Shader.h"
#include <vector>
#include "Ground.h"

namespace cgue{
	namespace thewall{
		namespace scene{
			class Slander :
				public SceneObject
			{
			public:
				Slander(glm::mat4& matrix, Shader* _shader);
				virtual ~Slander(void);

				virtual void update(float deltaT);
				virtual void draw();
				virtual void drawDepth();

				void setModelMatrix(glm::mat4 mm);
				void setModelMatrix(btRigidBody* SlanderRigidBody);
				GLuint vao;
				GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer;
				Shader* shader;
				
				virtual void setSurfaceParameters();
				std::vector< glm::vec3 > vertices;
				std::vector< glm::vec2 > uvs;
				std::vector< glm::vec3 > normals;
				std::vector< unsigned short > indices;

				};
		}
	}
}
