#pragma once

#include <GL/glew.h>
#include <glm\glm.hpp>
#include "SceneObject.h"
#include "../Shader.h"
#include <vector>
#include "bullet-2.81-rev2613\src\btBulletDynamicsCommon.h"

namespace cgue{
	namespace thewall{
		namespace scene{
			class Surrounding:
				public SceneObject
			{
			public:
				Surrounding(glm::mat4& matrix, Shader* _shader);
				virtual ~Surrounding(void);

				virtual void update(float deltaT);
				virtual void draw();
				btBvhTriangleMeshShape* collisionShape;
				float findHigh(float x, float z);
				void setModelMatrix(btRigidBody* groundRigidBody);

			private:
				GLuint vao;
				GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer;
				Shader* shader;

				virtual void generateCollisionShape();
				virtual void setSurfaceParameters();
				std::vector< glm::vec3 > vertices;
				std::vector< glm::vec2 > uvs;
				std::vector< glm::vec3 > normals;
				std::vector< unsigned int > indices;
			};
		}
	}
}