#pragma once

#include <GL/glew.h>
#include <glm\glm.hpp>
#include "SceneObject.h"
#include "Ground.h"
#include "../Shader.h"
#include <vector>

namespace cgue{
	namespace thewall{
		namespace scene{
			class Tree :
				public SceneObject
			{
			public:
				Tree(glm::mat4& matrix, Shader* _shader);
				virtual ~Tree(void);

				virtual void update(float deltaT);
				virtual void draw();
				virtual void drawDepth();
				void setModelMatrix(btRigidBody* treeRigidBody);
				
				

				static GLuint vao;
				static GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer, tangentBuffer, bitangentBuffer;
				Shader* shader;

				virtual void setSurfaceParameters();

				static std::vector< glm::vec3 > vertices;
				static std::vector< glm::vec2 > uvs;
				static std::vector< glm::vec3 > normals;

				static std::vector<glm::vec3> tangents;
				static std::vector<glm::vec3> bitangents;

				static std::vector<unsigned short> indices;
			};
		}
	}
}
