#pragma once

#include <GL/glew.h>
#include "SceneObject.h"
#include "../Shader.h"

#define TRIANGLE_VERTEX_COUNT 3
#define TRIANGLE_INDEX_COUNT 3

namespace cgue{
	namespace thewall{
		namespace scene{
			class Triangle :
				public SceneObject
			{
			public:
				Triangle(glm::mat4& matrix, Shader* _shader);
				virtual ~Triangle(void);

				virtual void update(float deltaT);
				virtual void draw();

			private:
				GLuint vao;
				GLuint positionBuffer, indexBuffer;
				Shader* shader;

				static const float positions[TRIANGLE_VERTEX_COUNT * 3];
				static const unsigned int indices[TRIANGLE_INDEX_COUNT];
			};
		}
	}
}

