#pragma once

#include <GL/glew.h>
#include <glm\glm.hpp>
#include "SceneObject.h"
#include "../Shader.h"
#include <vector>
#include "../Texture.h"

namespace cgue{
	namespace thewall{
		namespace scene{
			class Wall :
				public SceneObject
			{
			public:
				Wall(glm::mat4& matrix, Shader* _shader);
				virtual ~Wall(void);

				virtual void update(float deltaT);
				virtual void draw();
				virtual void drawDepth();
				void setModelMatrix(btRigidBody* WallRigidBody);
				
				Texture* text;
				Texture* textNorm;

				GLuint vao;
				GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer, tangentBuffer, bitangentBuffer;
				Shader* shader;
	
				btBvhTriangleMeshShape* collisionShape;
			
				virtual void setSurfaceParameters();
				void generateCollisionShape();
				std::vector< glm::vec3 > vertices;
				std::vector< glm::vec2 > uvs;
				std::vector< glm::vec3 > normals;

				std::vector<glm::vec3> tangents;
				std::vector<glm::vec3> bitangents;

				std::vector<unsigned short> indices;
			};
		}
	}
}
