#pragma once

#include <GL/glew.h>
#include <glm/glm.hpp>
#include <glm/gtc/matrix_transform.hpp> 
#include "SceneObject.h"
#include "../Shader.h"
#include <vector>
#include "Ground.h"
#include <iostream>

namespace cgue{
	namespace thewall{
		namespace scene{
			class Wing :
				public SceneObject
			{
			public:
				Wing(glm::mat4& matrix, Shader* _shader, std::string _path);
				virtual ~Wing(void);

				virtual void update(float deltaT);
				virtual void draw();
				virtual void drawDepth();

				void setFly(bool b);
				void setDirection(glm::vec3 dir);
				void setModelMatrix(glm::mat4 mm);
				bool mirrored;
			private:
				std::string path;
				GLuint vao;
				GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer;
				Shader* shader;

				glm::vec3 direction;

				virtual void setSurfaceParameters();
				std::vector< glm::vec3 > vertices;
				std::vector< glm::vec2 > uvs;
				std::vector< glm::vec3 > normals;
				std::vector< unsigned short > indices;

				bool fly;
				float changeWingdir;
			};
		}
	}
}
