#pragma once

#include <string>
#include <GL/glew.h>
#include <GLFW/glfw3.h>

namespace cgue{
	namespace thewall{
		class Shader
		{
		public:
			Shader(const std::string& vertexShader, const std::string& fragmentShader);
			Shader(const std::string& vertexShader, const std::string& fragmentShader, const std::string& geometryShader);

			~Shader(void);

			void useShader() const;

			GLuint programHandle;

		private:

			void loadShader(const std::string& shader, GLenum shaderType, GLuint& handle);
			GLuint LoadShaders(const std::string& vertex_file_path,const std::string& fragment_file_path);
			void link();
			GLuint vertexHandle;
			GLuint fragmentHandle;
			GLuint geometryHandle;
		};
	}
}