#version 330 core

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 normalCameraSpace;
out vec2 fUVs;
out vec3 lightDirectionCameraSpace;
out vec3 eyeDirectionCameraSpace;
out vec3 positionWorldSpace;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 modelMatrix;
uniform vec3 lightPositionWorldSpace;
uniform mat4 PVM;	//projectionMatrix*viewMatrix*modelMatrix
uniform mat4 VM;			//ViewMatrix* modelMatrix

out vec4 shadowCoord;
uniform mat4 depthBiasVP;

void main(){
	mat4 depthBiasMVP = depthBiasVP * modelMatrix;
	shadowCoord = depthBiasMVP * vec4(position,1);


	fUVs = uv;
	gl_Position = PVM* vec4(position, 1);

	normalCameraSpace = (VM*vec4(normal,0)).xyz;

	

	positionWorldSpace = (modelMatrix*vec4(position,1)).xyz;

	vec3 positionCameraSpace = (VM*vec4(position,1)).xzy;
	eyeDirectionCameraSpace = vec3(0,0,0) - positionCameraSpace;

	vec3 lightPositionCameraSpace = (viewMatrix * vec4(lightPositionWorldSpace,1)).xzy;
	lightDirectionCameraSpace = lightPositionCameraSpace + eyeDirectionCameraSpace;

}
