#pragma once

#include <GL/glew.h>
#include "Shader.h"
#include "MausKeyboard.h"
#include "Scene/Ground.h"
#include "Scene/Raven.h"
#include "Scene/Stone.h"
#include "Scene/Key.h"
#include "Scene/Tree.h"

namespace cgue {
	namespace thewall {
		class ShadowMap
		{
		public:
			ShadowMap(int _WIDTH, int _HEIGHT);
			~ShadowMap(void);
			static const GLfloat g_quad_vertex_buffer_data[18];
			Shader* shaderDepth;
			GLuint depthMatrixID;
			GLuint FramebufferName;
			GLuint depthTexture;
			GLuint quad_vertexbuffer;
			Shader* shaderQuad;
			GLuint texID;

			int WIDTH, HEIGHT;

			void initDepth(Shader * shader, GLuint& DepthBiasID, GLuint& ShadowMapID, Shader * shaderNormal, GLuint& DepthBiasIDNM, GLuint& ShadowMapIDNM);

			void drawDepth(MausKeyboard* mk, Ground* ground, Raven* raven, Stone* stone, Key* key[], Tree* tree[], int treelength, GLuint DepthBiasID, GLuint DepthBiasIDNM, 
				glm::vec3 lightPos, glm::vec3 lightInvDir, Shader* shader, Shader* shaderNormal);
			void activateDepthTexture(GLuint ShadowMapID);

			void drawAfter();
		};
	}
}