#pragma once

#include "Texture.h"
#include <gl/glew.h>
#include <glm/glm.hpp>
#include <windows.h>
#include "Info.h"
#include <vector>
#include "Shader.h"

#define SKYFRONT 0						// Give Front ID = 0
#define SKYBACK  1						// Give Back  ID = 1
#define SKYLEFT  2						// Give Left  ID = 2
#define SKYRIGHT 3						// Give Right ID = 3
#define SKYUP    4						// Give Up    ID = 4
#define SKYDOWN  5						// Give Down  ID = 5

using namespace std;
using namespace cgue::thewall;

/********************************

Class:		CSkybox

Purpose:	Class for using skybox.

********************************/
namespace cgue{
	namespace thewall{
		class Skybox
		{
		public:
			Skybox(Shader* _shader);
			~Skybox(void);
			void draw();
		private:
			std::vector< glm::vec3 > vertices;
			std::vector< glm::vec2 > uvs;
			std::vector< glm::vec3 > normals;
			Texture* tTextures[6];
			Shader* shader;
			GLuint vao;
			GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer;
		};
	}
}