#include "SpotLight.h"

using namespace cgue::thewall;
SpotLight::SpotLight()
{
	vColor = glm::vec3(1.0f, 1.0f, 1.0f);
	vPosition = glm::vec3(0.0f, 0.0f, 0.0f);
	vDirection = glm::vec3(0.0f, 0.0f, -1.0f);

	bOn = 1.0f;
	fConeAngle = 20.0f;
	fLinearAtt = 0.02f;
}

SpotLight::SpotLight(glm::vec3 a_vColor, glm::vec3 a_vPosition, glm::vec3 a_vDirection, float a_bOn, float a_fConeAngle, float a_fLinearAtt)
{
	vColor = a_vColor;
	vPosition = a_vPosition;
	vDirection = a_vDirection;
	
	bOn = a_bOn;
	fConeAngle = a_fConeAngle;
	fLinearAtt = a_fLinearAtt;
}

void SpotLight::SetUniformData(Shader* spProgram, std::string sLightVarName)
{
	spProgram->useShader();
	GLint iLoc = glGetUniformLocation(spProgram->programHandle, (sLightVarName+".vColor").c_str());
	glUniform3fv(iLoc, 1, (GLfloat*)&vColor);
	iLoc = glGetUniformLocation(spProgram->programHandle, (sLightVarName+".vPosition").c_str());
	glUniform3fv(iLoc, 1, (GLfloat*)&vPosition);
	iLoc = glGetUniformLocation(spProgram->programHandle, (sLightVarName+".vDirection").c_str());
	glUniform3fv(iLoc, 1, (GLfloat*)&vDirection);

	iLoc = glGetUniformLocation(spProgram->programHandle, (sLightVarName+".bOn").c_str());
	glUniform1f(iLoc, bOn);
	iLoc = glGetUniformLocation(spProgram->programHandle, (sLightVarName+".fConeAngle").c_str());
	glUniform1f(iLoc, fConeAngle);
	iLoc = glGetUniformLocation(spProgram->programHandle, (sLightVarName+".fConeCosine").c_str());
	glUniform1f(iLoc, float(cos(fConeAngle*3.1415f/180.0f)));
	iLoc = glGetUniformLocation(spProgram->programHandle, (sLightVarName+".fLinearAtt").c_str());
	glUniform1f(iLoc, fLinearAtt);

}

