#include "Texture.h"
#include <FreeImage.h>
#include <iostream>


using namespace cgue;
using namespace cgue::thewall;
//using namespace cgue::util;

Texture::Texture(const std::string& path)
{
	glGenTextures(1, &handle);
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, handle);

	unsigned int width, height;
	unsigned char* data = loadTexture(path, width, height);

	glTexImage2D(GL_TEXTURE_2D, 0,GL_RGBA, width, height, 0, GL_RGBA, GL_UNSIGNED_BYTE, data);
	glGenerateMipmap(GL_TEXTURE_2D);

	//Try linear filtering
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

}
//Lscht die Textur
Texture::~Texture(void){
	glDeleteTextures(1, &handle);
}

void Texture::Bind(int unit)
{
	glActiveTexture(GL_TEXTURE0 + unit);
	glBindTexture(GL_TEXTURE_2D, handle);
}
//Ldt die Textur mit dem angegebenen Pfad
//Dadurch dass ich die Referenz auf die Breite und Hhe bergebe, werden diese auch gendert
unsigned char* Texture::loadTexture(const std::string& path, unsigned int& width, unsigned int& height)
{
	//path.c_str() koncertiert einen String in const char*
	FREE_IMAGE_FORMAT format = FreeImage_GetFileType(path.c_str(), 0);
	FIBITMAP* image = FreeImage_Load(format, path.c_str());

	FIBITMAP* temp = image;
	image = FreeImage_ConvertTo32Bits(image);
	FreeImage_Unload(temp);

	width = FreeImage_GetWidth(image);
	height = FreeImage_GetHeight(image);
	//std::cout <<"The size of the image is: "<<path.c_str()<<" es "<<width<<"*"<<height<<std::endl; //Some debugging code
	
	GLubyte* textur = new GLubyte[4*width*height];
	char* pixel = (char*)FreeImage_GetBits(image);

	//FreeImage loads in RGB BRG, so you need to swap some bytes
	for(unsigned int j= 0; j<width*height; j++){
		textur[j*4+0]= pixel[j*4+2];
		textur[j*4+1]= pixel[j*4+1];
		textur[j*4+2]= pixel[j*4+0];
		textur[j*4+3]= pixel[j*4+3];
		//cout<<j<<": "<<textura[j*4+0]<<"**"<<textura[j*4+1]<<"**"<<textura[j*4+2]<<"**"<<textura[j*4+3]<<endl;
	}
 
	return textur;
}