#define GLEW_NO_GLU
#define GLFW_NO_GLU
#define GLM_FORCE_RADIANS


// Include GLEW
#include <GL/glew.h>
#include <GL/freeglut.h>

// Include GLFW
#include <GLFW/glfw3.h>

// Include GLM
#include <glm/glm.hpp>
#include <glm/gtc/type_ptr.hpp>
// glm::translate, glm::rotate, glm::scale
#include <glm/gtc/matrix_transform.hpp> 

//Include Bullet
#include "BulletDebugDraw.h"

//#include <iostream>

//Eigene Headerfiles
#include "Shader.h"
#include "Scene/Tree.h"
#include "Scene/Stone.h"
#include "Scene/Slander.h"
#include "Scene/Ground.h"
#include "Texture.h"
#include "Scene/Key.h"
#include "Scene/Cube.h"
#include "BulletPhysics.h"
#include "Music.h"
#include "ShadowMap.h"
#include "Scene\Surrounding.h"

#include "Scene/Raven.h"

#include <stdlib.h>
#include <time.h>

//Maus and Keyboard
#include "MausKeyboard.h"

#include "SpotLight.h"
#include "Skybox.h"
#include "Fbo.h"

#include "Info.h"
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <algorithm>
#include <iterator>

using namespace glm;
using namespace cgue::thewall;
using namespace cgue::thewall::scene;

GLFWwindow* window;

Skybox* skybox;

//Objekte
Shader* shader;
Shader* shaderNormal;
Shader* shaderSkyBox;
ShadowMap* shadowMap;
GLuint DepthBiasID;
GLuint ShadowMapID;
GLuint DepthBiasIDNM;
GLuint ShadowMapIDNM;
const int treelength = 15*15;
Tree* tree[treelength];
Stone* stone;
Slander* slander;
Ground* ground;
Key* key[5];
Cube* cube;
Raven* raven;
Music* music;
Surrounding* surrounding;

//Texturen
Texture* texture;
Texture* textureStone;
Texture* textureSlander;
Texture* textureKey;
Texture* textureCube;

//Normal
Texture* textureNormalTree;

//Maus and Keyboard
MausKeyboard* mk;

SpotLight* spotLight;

//Bullet Elements
BulletPhysics* bulletPhysics;
BulletDebugDraw* mydebugdrawer;




//Objekte
Shader* gaussHorizontalShader;
Shader* gaussFinalShader;
Shader* textureShader;
Shader* endGameShader;

Fbo* fbo;

//Texturen
Texture* textureGameOver;
Texture* textureWinGame;


bool stoneBool = false;
bool drawStone = false;
float stoneFloat = 0.0f;
int keyFound;
bool running = true;
bool* keyStates = new bool[256];
bool spotlighton = true;
bool drawSlander;

int sekunden;
bool gameWin;
glm::mat4 PVM ; //ProjectionViewModel Matrix
glm::mat4 VM; //ViewModelMatrix

int WIDTH = 1366;
int HEIGHT = 768;

double xpos = WIDTH/2;
double ypos = HEIGHT/2;

void init();
void update(float deltaT);
void Cleanup();
void draw();
void tasten(unsigned char key, int xmouse, int ymouse);
void tastenUP (unsigned char key, int xmouse, int ymouse);
void mouse(int x, int y);
void mouseClicked(int button, int state, int x, int y);
void keyOperations (void);
void loadScreenSize(int& w, int& h);


void loadScreenSize(int& w, int& h){
	ifstream file(ORDNER + std::string("WindowSize.txt"));
	if (file.good()){
		string size = string(istreambuf_iterator<char>(file), istreambuf_iterator<char>());
		file.close();

		std::stringstream ss(size);
		std::string wi;
		std::getline(ss, wi, '\n');
		std::string he;
		std::getline(ss, he, '\n');
		ss.str("");
		ss.clear();
		ss<<wi;
		ss>>w;
		ss.str("");
		ss.clear();
		ss<<he;
		ss>>h;
		ss.str("");
		ss.clear();
	}
}

int main(int argc, char** argv){

	int w, h;
	w=0;
	h=0;

	loadScreenSize(w,h);

	if(w == 0 ||h == 0)
		exit(-1);

	WIDTH = w;
	HEIGHT = h;

	for(int i = 0; i < 256; i++)
		keyStates[i] = false;

	if (!glfwInit())
	{
		std::cout << "Failed to init glfw" << std::endl;
		system("PAUSE");
		exit(-1);
	} 

		// set window hints



	glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA); // enabling double buffering and RGBA
    glutInitWindowSize(WIDTH, HEIGHT);
	glutInitWindowPosition(0,0);
    glutCreateWindow("CGUE"); // creating the window
    glutFullScreen();           // making the window full screen
	glutSetCursor(GLUT_CURSOR_NONE);

//	glfwWindowHint(GLFW_OPENGL_PROFILE, GLFW_OPENGL_CORE_PROFILE);
	int refresh_rate = 60;
	glfwWindowHint(GLFW_REFRESH_RATE, refresh_rate);

	// init glew
	glewExperimental = true;
	if (glewInit() != GLEW_OK)
	{
		std::cout << "failed to initialize glew" << std::endl;
		system("pause");
		exit(-1);
	}
	
	float deltaT;
	double time = glfwGetTime();
	double lastTime = time;
	double timeclock = 0;
	glEnable(GL_TEXTURE_2D);
	// Optimierung
	init();
	glutKeyboardFunc(tasten);
	glutKeyboardUpFunc(tastenUP);
	glutPassiveMotionFunc(mouse);
	glutMouseFunc(mouseClicked);
	do{
		// clear the frame and depth buffer
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		// compute the frame time delta
		time = glfwGetTime();
		deltaT = time - lastTime;
		lastTime = time;

		timeclock += deltaT;
		if(timeclock >= 1.0){
			sekunden++;
			timeclock = 0.0;
		}
		// react to user input
		glfwPollEvents();
		

		// Update all game components
		update(deltaT);
		// draw all game components
		draw();
		glutSwapBuffers();
		keyOperations();
		glutWarpPointer(WIDTH/2, HEIGHT/2);
		// check for errors
		
		int err = glGetError();
		if (err != GL_NO_ERROR)
			std::cout << "GL ERROR DETECTED!!! " << err << std::endl;
	}while (running);

	// clean up!
	Cleanup();
	glfwTerminate();
}




void update(float deltaT){
	
	music->getSystem()->update();
	
	if(sekunden > 180){
		//Spiele hier neuen Sound ab
		music->stopBackgroundMusic();
		music->playGameOverSound();
		
	}else{
	
		if(!drawSlander && sekunden >= 160){ //Der Slander soll erstellt werden n
			bulletPhysics->initSlanderRigidBody();
			slander->setModelMatrix(bulletPhysics->getSlanderRigidBody());
			drawSlander = true;
		}

	

		(bulletPhysics->getDynamicWorld())->stepSimulation(deltaT, 10.0f);

		// Compute the MVP matrix from keyboard and mouse input
		mk->computeMatricesFromInputs(deltaT, WIDTH, HEIGHT, &stoneBool, bulletPhysics->getCameraRigidBody());
		glm::mat4 projectionMatrixMat = mk->getProjectionMatrix();
		glm::mat4 viewMatrixMat = mk->getViewMatrix();
		PVM = projectionMatrixMat*viewMatrixMat;
		VM = viewMatrixMat;


		glm::vec3 vSpotLightPos = mk->getPosition();
		glm::vec3 vCameraDir = glm::normalize(mk->direction);
		// Move down a little
		vSpotLightPos.y -= 0.5f;
		// Find direction of spotlight
		glm::vec3 vSpotLightDir = (vSpotLightPos+vCameraDir*75.0f)-vSpotLightPos;
		vSpotLightDir = glm::normalize(vSpotLightDir);
		// Find vector of horizontal offset
		glm::vec3 vHorVector = glm::cross(mk->direction, mk->getUp());
		vSpotLightPos += vHorVector*0.5f;

		spotLight->vPosition = vSpotLightPos;
		spotLight->vDirection = vSpotLightDir;
		spotLight->SetUniformData(shader, "spotLight");
		spotLight->SetUniformData(shaderNormal, "spotLight");

		if(spotlighton){
			spotLight->bOn -= deltaT / 120.0f;
			if(spotLight->bOn < 0.0f)
				spotLight->bOn = 0.0f;
		}

		shaderSkyBox->useShader();
		glUniformMatrix4fv(
			glGetUniformLocation(shaderSkyBox->programHandle, "projectionMatrix"), 1, 
		GL_FALSE,&projectionMatrixMat[0][0]);
		glUniformMatrix4fv(
			glGetUniformLocation(shaderSkyBox->programHandle, "viewMatrix"), 1, 
		GL_FALSE,&viewMatrixMat[0][0]);
		glm::mat4 modelMatrixMat = glm::translate(glm::mat4(1.0f), mk->getPosition());
		
		glUniformMatrix4fv(
			glGetUniformLocation(shaderSkyBox->programHandle, "modelMatrix"), 1, 
		GL_FALSE,&modelMatrixMat[0][0]);
	
		mydebugdrawer->SetMatrices(viewMatrixMat,  projectionMatrixMat);

		shader->useShader();
		GLuint shaderPM = glGetUniformLocation(shader->programHandle,"projectionMatrix");
		GLuint shaderVM = glGetUniformLocation(shader->programHandle,"viewMatrix");
		glUniformMatrix4fv(shaderPM, 1, GL_FALSE, &projectionMatrixMat[0][0]);
		glUniformMatrix4fv(shaderVM, 1, GL_FALSE, &viewMatrixMat[0][0]);
		shaderNormal->useShader();
		GLuint shaderNormalPM = glGetUniformLocation(shaderNormal->programHandle,"projectionMatrix");
		GLuint shaderNormalVM = glGetUniformLocation(shaderNormal->programHandle,"viewMatrix");
		glUniformMatrix4fv(shaderNormalPM, 1, GL_FALSE, &projectionMatrixMat[0][0]);
		glUniformMatrix4fv(shaderNormalVM, 1, GL_FALSE, &viewMatrixMat[0][0]);


		if(stoneBool){
		
			if(bulletPhysics->getStoneRigidBody()== NULL){
				drawStone = true;
				bulletPhysics->initStoneRigidBody();
				bulletPhysics->setStoneBool(true);
				mk->setStoneRigidBody(bulletPhysics->getStoneRigidBody());
			}
			stone->setModelMatrix(bulletPhysics->getStoneRigidBody());
			
		}
	
	
		float posx = mk->getPosition()[0];
		float posz = mk->getPosition()[2];

		//Manuell berprfen ob Schlssel gefunden wurde
		
		for(int i = 0; i < 5; i++){
			if(key[i] != NULL){
				int h = (int)glm::sqrt(pow(key[i]->modelMatrix[3][0] - posx,2) + pow(key[i]->modelMatrix[3][2] - posz,2));
					if(h <= 0.8){
						bulletPhysics->collisionWithKey(i);
						
						music->playKeySound();
						keyFound++;
						//Der gefundene Schlssel muss gelscht werden
						delete key[i];
						key[i] = NULL;
	
						if(keyFound == 5){
							gameWin =true;
						}
		
					
					}
				}
		}
	
		if(!stoneBool && drawStone){
			int h = (int)glm::sqrt(pow(stone->modelMatrix[3][0] - posx,2) + pow(stone->modelMatrix[3][2] - posz,2));
				if(h <= 0.5){
					bulletPhysics->collisionWithStone();
					bulletPhysics->setStoneBool(false);
					drawStone = false;
					mk->setStoneRigidBody(bulletPhysics->getStoneRigidBody());
					music->playPlopSound();	
				}
		}


		//Schauenn, ob man einen Schlssel gefunden hat
		std::vector<int>* collision = new std::vector<int>();

		bulletPhysics->checkCollision(collision);
	
		for(int i = 0; i < collision->size(); i++){
			/*if(collision->at(i) >= 1 && collision->at(i) <=5){
				std::cout<<"ICh habe einen Schlssel gefunden"<<std::endl;
				music->playKeySound();
				keyFound++;
				//Der gefundene Schlssel muss gelscht werden
				delete key[collision->at(i)-1];
				key[collision->at(i)-1] = NULL;
	
				if(keyFound == 5){
					gameWin =true;
				}
			}*/if(collision->at(i) == 7){//Erkennt Kollision von Stein mit Boden, Stein bleibt liegen
				//music->playPlopSound();
				stoneBool = false;
				mk->setStoneFalse();
			}/*else if(!stoneBool && collision->at(i) == 6){   //Ich sammel Stein wieder auf
					bulletPhysics->setStoneBool(false);
					drawStone = false;
					mk->setStoneRigidBody(bulletPhysics->getStoneRigidBody());
					music->playPlopSound();	
			}*/else if(drawSlander && collision->at(i) == 9){//Der Stein trifft den Slander Man, ich gewinne 30 Sekunden.
				
				std::cout<<"Kollision wird berprft"<<std::endl;
				stoneBool = false;
				mk->setStoneFalse();

				sekunden -= 30;
				music->playSlanderSound();
				drawSlander = false;

				bulletPhysics->setStoneBool(false);
				drawStone = false;
				mk->setStoneRigidBody(bulletPhysics->getStoneRigidBody());
			
			}
		
	}
		
		//stoneBool ist true, wenn er geworfen wurde. 
		bulletPhysics->getRavenRigidBody()->activate();
		bulletPhysics->getRavenRigidBody()->setLinearVelocity(btVector3(1,0,0));
		raven->setModelMatrix(bulletPhysics->getRavenRigidBody());
		raven->update(deltaT);
}
	shader->useShader();
	glUniform3fv(glGetUniformLocation(shader->programHandle, "position"), 1, glm::value_ptr(mk->getPosition()));
	shaderNormal->useShader();
	glUniform3fv(glGetUniformLocation(shaderNormal->programHandle, "position"), 1, glm::value_ptr(mk->getPosition()));
}
//Alle Initialisierten Objekte werden wieder gelscht
void Cleanup(){
	delete shader;
	delete shaderNormal;
	delete shaderSkyBox;
	delete shadowMap;
	for(int i = 0; i < treelength; i++)
		delete tree[i];
	delete stone;
	delete slander;
	delete ground;
	delete cube;
	delete texture;
	delete textureStone;
	delete textureSlander;
	delete textureNormalTree;
	delete textureKey;
	delete textureCube;
	delete mk;
	delete spotLight;
	delete keyStates;
	for(int i = 0; i < 4; i++){
		delete key[i];
	}
	delete bulletPhysics;
	
	delete skybox;

	delete textureShader;
}

void draw(){
	if(sekunden > 180){
	fbo->endGame(endGameShader,textureGameOver);
	return;
	}
	else if(gameWin){
	fbo->endGame(endGameShader,textureWinGame);
	return;
	}

	glBindFramebuffer(GL_FRAMEBUFFER, fbo->getFbo());
	glViewport(0,0,WIDTH, HEIGHT);

	glDrawBuffer(GL_COLOR_ATTACHMENT0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glBindFramebuffer(GL_FRAMEBUFFER,0);

	glBindFramebuffer(GL_FRAMEBUFFER, fbo->getFbo());
	glViewport(0,0,WIDTH, HEIGHT);
	glDrawBuffer(GL_COLOR_ATTACHMENT1);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glBindFramebuffer(GL_FRAMEBUFFER,0);

	glBindFramebuffer(GL_FRAMEBUFFER, fbo->getFbo());
	glViewport(0,0,WIDTH, HEIGHT);
	
	GLenum buffers[] = {GL_COLOR_ATTACHMENT0, GL_COLOR_ATTACHMENT1};
    glDrawBuffers(2, buffers);

	int unit = 0;
	shader->useShader();
	glUniform1f(glGetUniformLocation(shader->programHandle, "alpha"), 0.0);
	textureStone->Bind(unit);
	glUniform1i(glGetUniformLocation(shader->programHandle, "colorTexture"), unit);
	//Push matrix to shader, muss einmal pro Frame ausgefhrt werden, also jedes Mal, wenn sie sich ndert
	glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"modelMatrix"), 1,
		GL_FALSE, glm::value_ptr(stone->modelMatrix));
	glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"PVM"), 1,
		GL_FALSE, glm::value_ptr(PVM*(stone->modelMatrix)));
	glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"VM"), 1,
		GL_FALSE, glm::value_ptr(VM*(stone->modelMatrix)));
	
	if(drawStone){
		stone->draw();
	}

	if(drawSlander){
	textureSlander->Bind(unit);
	glUniform1f(glGetUniformLocation(shader->programHandle, "alpha"), 0.0);
	textureStone->Bind(unit);
	glUniform1i(glGetUniformLocation(shader->programHandle, "colorTexture"), unit);
	//Push matrix to shader, muss einmal pro Frame ausgefhrt werden, also jedes Mal, wenn sie sich ndert
	glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"modelMatrix"), 1,
		GL_FALSE, glm::value_ptr(slander->modelMatrix));
	glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"PVM"), 1,
		GL_FALSE, glm::value_ptr(PVM*(slander->modelMatrix)));
	glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"VM"), 1,
		GL_FALSE, glm::value_ptr(VM*(slander->modelMatrix)));
	
	slander->draw();
	}

	shaderNormal->useShader();
	glUniformMatrix4fv(glGetUniformLocation(shaderNormal->programHandle,"modelMatrix"), 1,
		GL_FALSE, glm::value_ptr(ground->modelMatrix));

	glUniformMatrix4fv(glGetUniformLocation(shaderNormal->programHandle,"PVM"), 1,
		GL_FALSE, glm::value_ptr(PVM*ground->modelMatrix));

	glUniformMatrix4fv(glGetUniformLocation(shaderNormal->programHandle,"VMV"), 1,
		GL_FALSE, glm::value_ptr(VM*ground->modelMatrix));

	ground->draw();
	float posx = mk->getPosition()[0];
	float posz = mk->getPosition()[2];

	shader->useShader();
	textureKey->Bind(unit);
	glUniform1i(glGetUniformLocation(shader->programHandle, "colorMap"), unit);

	for(int i = 0; i < 5; i++){
		if(key[i] != NULL){
		int h = (int)glm::sqrt(pow(key[i]->modelMatrix[3][0] - posx,2) + pow(key[i]->modelMatrix[3][2] - posz,2));
		if(h < 20){
			glUniform1f(glGetUniformLocation(shader->programHandle, "alpha"), 1.0);
	
			glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"modelMatrix"), 1,
				GL_FALSE, glm::value_ptr(key[i]->modelMatrix));
			
			glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"PVM"), 1,
				GL_FALSE, glm::value_ptr(PVM*key[i]->modelMatrix));
		
			glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"VM"), 1,
				GL_FALSE, glm::value_ptr(VM*key[i]->modelMatrix));
			key[i]->draw();
		}
		}
	}
	
	shader->useShader();
	
	raven->texture->Bind(unit);
	glUniform1i(glGetUniformLocation(shader->programHandle, "colorMap"), unit);

			glUniform1f(glGetUniformLocation(shader->programHandle, "alpha"), 0.0);
	
			glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"modelMatrix"), 1,
				GL_FALSE, glm::value_ptr(raven->modelMatrix));
			
			glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"PVM"), 1,
				GL_FALSE, glm::value_ptr(PVM*raven->modelMatrix));
		
			glUniformMatrix4fv(glGetUniformLocation(shader->programHandle,"VM"), 1,
				GL_FALSE, glm::value_ptr(VM*raven->modelMatrix));
			
	raven->draw();
			
	shaderNormal->useShader();

	texture->Bind(unit);
	glUniform1i(glGetUniformLocation(shaderNormal->programHandle, "colorTexture"), unit);
	textureNormalTree->Bind(2);
	glUniform1i(glGetUniformLocation(shaderNormal->programHandle, "normalTexture"), 2);
	
	for(int i = 0; i < treelength; i++){
		int h = (int)glm::sqrt(pow(tree[i]->modelMatrix[3][0] - posx,2) + pow(tree[i]->modelMatrix[3][2] - posz,2));
		if(h < 20){
			glUniformMatrix4fv(glGetUniformLocation(shaderNormal->programHandle,"modelMatrix"), 1,
			GL_FALSE, glm::value_ptr(tree[i]->modelMatrix));
			
			glUniformMatrix4fv(glGetUniformLocation(shaderNormal->programHandle,"PVM"), 1,
			GL_FALSE, glm::value_ptr(PVM*tree[i]->modelMatrix));

			glUniformMatrix4fv(glGetUniformLocation(shaderNormal->programHandle,"VM"), 1,
			GL_FALSE, glm::value_ptr(VM*tree[i]->modelMatrix));
			
			tree[i]->draw();
		}
	}

	shaderSkyBox->useShader();

	skybox->draw();
	glBindFramebuffer(GL_FRAMEBUFFER,0);

	fbo->drawGaussTex(gaussHorizontalShader, gaussFinalShader);
	glEnable(GL_BLEND);

	//Auf den Screen zeichnen-----------------------------------------------------------------------------
	fbo->renderOnScreen(textureShader);
	//shadowMap->drawAfter();
}


void mouse(int x, int y) {
	mk->xpos_mouse(x);
	mk->ypos_mouse(y);
	
	//Ohne Sleep stockt es unmoeglich!!!
	Sleep(3);
}

void mouseClicked(int button, int state, int x, int y){
	if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
		keyStates[255] = true;
	if(button == GLUT_RIGHT_BUTTON && state == GLUT_UP)
		keyStates[255] = false;
	if(button == GLUT_LEFT_BUTTON && state == GLUT_UP){
		spotlighton = !spotlighton;
		spotLight->bOn = -spotLight->bOn;
	}
}

void tasten (unsigned char key, int xmouse, int ymouse)
{
	keyStates[key] = true;
}


void tastenUP (unsigned char key, int xmouse, int ymouse)
{
	keyStates[key] = false;
}

void keyOperations (void) {  
	if(keyStates['w'])
		mk->w_key_pressed();
	if(keyStates['s'])
		mk->s_key_pressed();
	if(keyStates['a'])
		mk->a_key_pressed();
	if(keyStates['d'])
		mk->d_key_pressed();
	if(keyStates['e'])
		mk->e_key_pressed();
	if(keyStates[GLFW_KEY_SPACE])
		mk->space_key_pressed();
	if(keyStates[255])
		mk->shift_key_pressed();
	if(keyStates[27])
		running = false;
}

void init(){
	
	glEnable(GL_TEXTURE_2D);
	glClearColor(0.1f, 0.1f, 0.1f, 1.0f);
	//Add depth test
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	
	

	gameWin =false;
	fbo = new Fbo(WIDTH, HEIGHT);

	glViewport(0, 0, WIDTH, HEIGHT);
	shader = new Shader(ORDNER + std::string("ShaderFile/vertex.vert"),
		ORDNER + std::string("ShaderFile/fragment.frag"));
	shaderNormal = new Shader(ORDNER + std::string("ShaderFile/vertexNM.vert"),
		ORDNER + std::string("ShaderFile/fragmentNM.frag"));
	shaderSkyBox = new Shader(ORDNER + std::string("ShaderFile/vertexSB.vert"),
		ORDNER + std::string("ShaderFile/fragmentSB.frag"));
	textureShader = new Shader(ORDNER + std::string("ShaderFile/texture.vert"),
		ORDNER + std::string("ShaderFile/texture.frag"));
	gaussHorizontalShader= new Shader(ORDNER + std::string("ShaderFile/texture.vert"),
		ORDNER + std::string("ShaderFile/gaussianHorizontal.frag"));
	gaussFinalShader= new Shader(ORDNER + std::string("ShaderFile/texture.vert"),
		ORDNER + std::string("ShaderFile/gaussFinal.frag"));
	endGameShader= new Shader(ORDNER + std::string("ShaderFile/texture.vert"),
		ORDNER + std::string("ShaderFile/endGame.frag"));

	shadowMap = new ShadowMap(WIDTH, HEIGHT);
	shader->useShader();
	surrounding = new Surrounding(glm::mat4(1.0f),shader);
	//Push projection matrix
	shader->useShader();
	bulletPhysics = new BulletPhysics();
	ground = new Ground(glm::mat4(1.0f),shaderNormal);
	bulletPhysics->setGround(ground);
	bulletPhysics->initGroundRigidBody(surrounding);
	//ground->setModelMatrix(bulletPhysics->getGroundRigidBody());
	//bulletPhysics->setGround(ground);



	bulletPhysics->initTreeRigidBody();
	bulletPhysics->initCharacterRigidBody();

	bulletPhysics->initRavenRigidBody();
	raven = new Raven(glm::mat4(1.0f),shader, 0, 0);
	raven->setModelMatrix(bulletPhysics->getRavenRigidBody());
	float rotate = 0.0f;
	shaderNormal->useShader();
	for(int i = 0; i < treelength; i++){
		tree[i] = new Tree(glm::mat4(1.0f),shaderNormal);
		tree[i]->setModelMatrix(bulletPhysics->getTreeRigidBody(i));
		tree[i]->modelMatrix = glm::rotate(tree[i]->modelMatrix, rotate, glm::vec3(0.0f,1.0f,0.0f));
		rotate += 271;
		rotate = (int)rotate % 360;
	}
	time_t t;
    time(&t);
    srand((unsigned int)t);  
	shader->useShader();
	//bulletPhysics->initKeyRigidBody();
	keyFound=0;
	
	int pos[5] = {2, 35, 28, 110, 212};
	for(int i = 0; i < 5; i++){
		key[i] = new Key(glm::mat4(1.0f),shader);
		//key[i]->setModelMatrix(bulletPhysics->getKeyRigidBody(i));
		key[i]->modelMatrix[3][0] = tree[pos[i]]->modelMatrix[3][0]+1.5;
		key[i]->modelMatrix[3][1] = ground->findHigh(tree[pos[i]]->modelMatrix[3][0]+1.5,tree[pos[i]]->modelMatrix[3][2]);
		key[i]->modelMatrix[3][2] = tree[pos[i]]->modelMatrix[3][2];
	}
	
	cube = new Cube(glm::mat4(1.0f),shader);
	//triangle = new Triangle(glm::mat4(1.0f),shader);
	glm::mat4 projection = glm::translate(
		glm::perspective(60.0f, (float)WIDTH / (float)HEIGHT, 0.01f, 20.0f),
		glm::vec3(0.0f,0.0f,-2.0f));
	glUniformMatrix4fv(
		glGetUniformLocation(shader->programHandle, "projectionMatrix"), 1, 
	GL_FALSE,glm::value_ptr(projection));
	glm::vec3 lightPos = glm::vec3(0.0f,15.0f,0.0f);
	glUniform3fv(glGetUniformLocation(shader->programHandle, "lightPositionWorldSpace"), 1, glm::value_ptr(lightPos));
	shaderNormal->useShader();
	glUniformMatrix4fv(
		glGetUniformLocation(shaderNormal->programHandle, "projectionMatrix"), 1, 
	GL_FALSE,glm::value_ptr(projection));
	glUniform3fv(glGetUniformLocation(shaderNormal->programHandle, "lightPositionWorldSpace"), 1, glm::value_ptr(lightPos)); //<-- Error
	shader->useShader();
	stone = new Stone(glm::mat4(1.0f), shader);
	slander = new Slander(glm::mat4(1.0f), shader);
	//Load texture
	texture = new Texture(ORDNER + std::string("Texturen/tree.jpg"));
	textureNormalTree = new Texture(ORDNER + std::string("Texturen/treeNormal.jpg"));
	textureStone = new Texture(ORDNER + std::string("Texturen/stone.jpg"));
	textureSlander = new Texture(ORDNER + std::string("Texturen/slander.jpg"));
	textureKey = new Texture(ORDNER + std::string("Texturen/key.jpg"));
	textureCube = new Texture(ORDNER + std::string("Texturen/skybox.jpg"));
		textureGameOver= new Texture(ORDNER + std::string("Texturen/gameOver.png"));
	textureWinGame = new Texture(ORDNER + std::string("Texturen/winGame.jpg"));

	mk = new MausKeyboard(ground);
	spotLight = new SpotLight(glm::vec3(1.0f, 1.0f, 1.0f), glm::vec3(0.0f, 0.0f, 0.0f), glm::vec3(0.0f, 0.0f, 0.0f), 1.0f, 15.0f, 0.017f);
	//stone->setGround(ground);
	mydebugdrawer = new BulletDebugDraw();
	(bulletPhysics->getDynamicWorld())->setDebugDrawer(mydebugdrawer);
	
	shaderSkyBox->useShader();
	skybox = new Skybox(shaderSkyBox);

	music = new Music();
	//shadowMap->initDepth(shader, DepthBiasID, ShadowMapID, shaderNormal, DepthBiasIDNM, ShadowMapIDNM);
	//glm::vec3 lightPosX = glm::vec3(0.5,5,2);
	glm::vec3 lightPosX = glm::vec3(0.5,2,2);
	glm::vec3 lightInvDirX = glm::vec3(0,0,0);
	shadowMap->initDepth(shader, DepthBiasID, ShadowMapID, shaderNormal, DepthBiasIDNM, ShadowMapIDNM);

	shadowMap->drawDepth(mk, ground, raven, stone, key, tree, treelength, DepthBiasID, DepthBiasIDNM, 
				lightPosX, lightInvDirX, shader, shaderNormal);
	shader->useShader();
	shadowMap->activateDepthTexture(ShadowMapID);
	shaderNormal->useShader();
	shadowMap->activateDepthTexture(ShadowMapIDNM);
}